package com.isu.gaswellwatch.utils;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.jsontype.TypeSerializer;
import org.springframework.core.convert.converter.Converter;

import java.io.IOException;
import java.time.LocalDateTime;
import java.util.Objects;

/**
 * @author <a href="mailto:scwsl@foxmail.com">王仕龙</a>
 * 2024/1/26 16:02
 */
public class LocalDateTimeToStringConverter extends JsonSerializer<LocalDateTime> implements Converter<LocalDateTime, String> {

    public static final LocalDateTimeToStringConverter INSTANCE = new LocalDateTimeToStringConverter();

    @Override
    public void serialize(LocalDateTime value, JsonGenerator jsonGenerator, SerializerProvider serializers) throws IOException {
        if (Objects.isNull(value)) {
            jsonGenerator.writeNull();
        } else {
            jsonGenerator.writeString(convert(value));
        }
    }

    @Override
    public void serializeWithType(LocalDateTime value, JsonGenerator gen, SerializerProvider serializers, TypeSerializer typeSer) throws IOException {
        serialize(value, gen, serializers);
    }

    @Override
    public String convert(LocalDateTime source) {
        if (Objects.isNull(source)) {
            return null;
        }
        return StringToLocalDateTimeConverter.ZH_CN_LOCAL_DATE_TIME.format(source);
    }

    @Override
    public Class<LocalDateTime> handledType() {
        return LocalDateTime.class;
    }

}